routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::group(['middleware' => ['web','auth'], 'prefix' => 'lk', 'as'=>'lk.'], function () {
    /*Route::get('products/upload', 'ProductsController@uploadFile')->name('products.upload');
    Route::resource('products', 'ProductsController');
    Route::resource('media', 'MediaController')->only(['update', 'destroy', 'store']);
    Route::resource('cart', 'CartController');
    Route::resource('checkout', 'CheckoutController');
    Route::resource('orders', 'OrderController');
    Route::resource('dashboard', 'DashboardController');
    //Route::resource('company', 'CompanyController');
    Route::resource('tenders', 'TendersController');
    Route::get('/requests/new', 'RequestsController@getNewRequest')->name('requests.new');
    Route::resource('requests', 'RequestsController');


    Route::post('/distributor/add_link', 'DistributorController@addLink')->name('distributor.add_link');*/

    Route::get('{any}', 'RoutingController@lk')->where('any', '.*');
});

Route::group(['middleware' => 'web', 'prefix' => '/'], function () {
    //Route::get('/login', 'RoutingController@auth')->name('login');
    //Route::get('/register', 'RoutingController@auth')->name('register');
    //Route::post('/register', 'Auth\RegisterController@register');
    Route::get('{first}/{second}/{third}', 'RoutingController@thirdLevel')->name('third');
    Route::get('{first}/{second}', 'RoutingController@secondLevel')->name('second');
    Route::get('{any}', 'RoutingController@root')->name('any');
});
// landing
Route::get('', 'RoutingController@index')->name('index');



Route::get('/login', 'RoutingController@auth');

Route::get('{any}', 'RoutingController@lk')->where('any', '.*');

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Laravel\Passport\HasApiTokens;
use Vanilo\Framework\Models\Product as VaniloProduct;
use Vanilo\Product\Contracts\Product as ProductContract;
use Vanilo\Properties\Models\Property;
use App\Services\ProductService;

class Product extends VaniloProduct implements ProductContract
{

    use HasApiTokens;

    protected $enums = [
        'status'=>ProductsEnum::class,
    ];

    public function isActive(): bool
    {
        return $this->status->isActive();
    }

    public function getPrice(): float
    {
        return $this->price;
    }

    public function properties($product_id)
    {
        return ProductService::getProperties($product_id);
    }
}

app/Http/Controllers/ProductsController.php
<?php

namespace App\Http\Controllers;

use App\Imports\ProductsImport;
use App\Models\Distributor;
use App\Models\Organization;
use App\Models\Product;
use App\Models\Tender;
use Illuminate\Http\Request;
use App\Models\Category;
use Illuminate\Support\Facades\View;
use App\Models\Region;
use App\Services\ProductService;
use Vanilo\Properties\Models\Property;
use Vanilo\Properties\Models\PropertyValue;
use App\Models\ProductsEnum;
use Vanilo\Product\Models\ProductStateProxy;
use Illuminate\Support\Facades\Auth;
use App\Models\ModelPropertyValue;
use Illuminate\Support\Str;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Session;
use Maatwebsite\Excel\Facades\Excel;
use App\Http\Controllers\Api\BaseController;

class ProductsController extends BaseController
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $type_organization = Organization::select('company_type')->where('user_id', Auth::id())->first();

        if($type_organization->company_type === 'manufacturer'){
            $products = Product::where('user_id', Auth::id())->paginate(16);
            return view('lk.products.index', ['products'=>$products]);
        }

        $tenders = Tender::getTenders();

        $companies_id = $c = [];

        $found = false;

        foreach ($tenders as $tender){

            $companies = Organization::where('min_sum_order','<=',$tender->sum)
                ->where('company_type','manufacturer')
                ->get();


            if(empty($companies))
                continue;
            else
                $found = true;

            $parameters = json_decode($tender->parameters);

            $sizes = $parameters->sizes;

            $products_id = ProductService::getTenderProductProperty($sizes);

            $segments = json_decode($tender->segment);

            $categories = json_decode($tender->categories);

            foreach ($categories as $category){
                $categories_data = Category::defaultOrder()->descendantsAndSelf($category->category_id);
                foreach ($categories_data as $cat){
                    $c[] = $cat->id;
                }

            }

            foreach ($companies as $company){
               $companies_id[] = $company->id;
            }

        }

        if($found){
            $products = Product::whereIn('id', $products_id)
                ->whereIn('company_id', $companies_id)
                ->whereIn('segment', $segments)
                ->whereIn('category_id', $c)
                ->paginate(16);
        }else{
            $products = [];
        }

        return view('lk.products.index', ['products'=>$products]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        return view('common');

        /*return view('lk.products.create', [
            'categories'=>$categories,
            'regions'=>$regions,
            'sizes'=>$sizes,
            'colors'=>$colors,
            'statuses'=>$statuses,
            'products'=>$products,
        ]);*/
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        if($request['product-modification'] != 0){
            $product_id = $request['product-modification'];
            $is_modification = true;
        }
        else{
            $product_id = Str::uuid();
            $is_modification = false;
        }

        $company_id = Organization::select('id')->where('user_id', Auth::id())->first();

        $product_data = [
            "product_id" => $product_id,
            "company_id" => $company_id->id,
            "name" => $request["product-name"] ?? '',
            "barcode" => $request["product-barcode"] ?? 0000000,
            "sku" => $request["product-sku"] ?? '',
            "user_id" => Auth::id(),
            "model" => $request["product-model"],
            "country_made_in" => $request["product-region"] ?? 0,
            "description" => $request["product-description"],
            "category_id" => $request["product-category"] ?? 0,
            "category_group_id" => $request["product-base_category"] ?? 0,
            "price" => $request["product-base_price"] ?? 0,
            "dropshipping_price" => $request["product-drop_price"],
            "discount" => $request["product-discount"] ?? 0,
            "recommended_retail_price" => $request["product-price"] ?? 0,
            "min_order" => $request["product-min_order"] ?? 1,
            "status" => $request["product-status"] ?? 'hidden',
            "segment" => $request["product-segment"] ?? '',
            "stock" => array_sum($request['product-sizes'] ?? []),
            'is_modification' => $is_modification,
        ];

        $product = ProductService::saveProduct($product_data);

        foreach ($request['product-sizes'] as $size_id=>$count){
            if(!is_null($count)){
                DB::insert('insert into model_property_values (property_value_id, model_type,model_id,stock) values (?, ?, ?, ?)', [$size_id,'product',$product->id, $count]);
            }
        }
        DB::insert('insert into model_property_values (property_value_id, model_type,model_id,stock) values (?, ?, ?, ?)', [$request["product-color"],'product',$product->id, 0]);

        flash()->success(__(':name has been created', ['name' => $product->name]));

        try {
            if (!empty($request->files->filter('images'))) {
                $product->addMultipleMediaFromRequest(['images'])->each(function ($fileAdder) {
                    $fileAdder->usingName(Str::random(16))->toMediaCollection();
                });
            }
        } catch (\Exception $e) { // Here we already have the product created
            flash()->error(__('Error: :msg', ['msg' => $e->getMessage()]));

            return redirect()->route('lk.products.create', ['product' => $product]);
        }

        return redirect()->route('lk.products.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $brand = Organization::select('id','brand')->where('user_id',$id->user_id)->get();

        $distributor = Distributor::where('retailer_id', Auth::id())->where('distributor_id', $id->user_id)->get();

        return view('lk.products.show', ['product'=>$id, 'brand'=>$brand, 'distributor'=>$distributor]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $id)
    {
        $categories = Category::where('depth', '>=', 1)->get();
        $regions = Region::where('depth', 1)->get();
        $colors = Property::findBySlug('color');
        $colors = PropertyValue::byProperty($colors)->get();
        $sizes = Property::findBySlug('size');
        $sizes = PropertyValue::byProperty($sizes)->get();

        $products = Product::where('user_id', Auth::id())->get();

        $statuses = [
            ProductsEnum::NEW_STATE         => 'Новинка',
            ProductsEnum::DRAFT_STATE       => 'Черновик',
            ProductsEnum::ACTIVE_STATE      => 'Активно',
            ProductsEnum::INACTIVE_STATE    => 'Не активно',
            ProductsEnum::UNAVAILABLE_STATE => 'Недоступно',
            ProductsEnum::PROMO_STATE       => 'Акция',
            ProductsEnum::HIDDEN_STATE      => 'Скрыто',
            ProductsEnum::DELETED_STATE     => 'Удалено',
            ProductsEnum::RECOMMENDED_STATE => 'Рекомендуемый',
            ProductsEnum::REPEAT_STATE      => 'Ожидается в повторе',
            ProductsEnum::PREORDER_STATE    => 'Предзаказ'
        ];

        $params = $id->properties($id->id);

        $color = $params['color'];

        $sizes_data = $params['size'];

        return view('lk.products.edit', [
            'product' => $id,
            'color'=>$color,
            'sizes_data'=>$sizes_data,
            'categories'=>$categories,
            'regions'=>$regions,
            'sizes'=>$sizes,
            'colors'=>$colors,
            'statuses'=>$statuses,
            'products'=>$products,
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Request $request, $id = null)
    {
        if($request['product-modification'] != 0){
            $product_id = $request['product-modification'];
            $is_modification = true;
        }
        else{
            $is_modification = false;
        }
        $product_data = [
            "product_id" => $product_id ?? $id->product_id,
            "name" => $request["product-name"] ?? '',
            "barcode" => $request["product-barcode"] ?? 0000000,
            "sku" => $request["product-sku"] ?? '',
            "model" => $request["product-model"],
            "country_made_in" => $request["product-region"] ?? 0,
            "description" => $request["product-description"],
            "category_id" => $request["product-category"] ?? 0,
            "category_group_id" => $request["product-base_category"] ?? 0,
            "price" => $request["product-base_price"] ?? 0,
            "dropshipping_price" => $request["product-drop_price"],
            "discount" => $request["product-discount"] ?? 0,
            "recommended_retail_price" => $request["product-price"] ?? 0,
            "min_order" => $request["product-min_order"] ?? 1,
            "status" => $request["product-status"] ?? 'hidden',
            "segment" => $request["product-segment"] ?? '',

resources/views/lk/products/create.blade.php
@extends('layouts.vertical', ['title' => 'Edit Products'])

@section('css')
    <!-- Plugins css -->
    <link href="{{asset('assets/libs/select2/select2.min.css')}}" rel="stylesheet" type="text/css" />
    <link href="{{asset('assets/libs/summernote/summernote.min.css')}}" rel="stylesheet" type="text/css" />
    <link href="{{asset('assets/libs/dropzone/dropzone.min.css')}}" rel="stylesheet" type="text/css" />
@endsection

@section('content')
        <!-- Start Content-->
    <div class="container-fluid">

        <div class="row">
            <div class="col-12">
                <div class="card-box">
                    <div class="row">
                        <div class="col-lg-8">

                        </div>
                        <div class="col-lg-4">
                            <div class="text-lg-right mt-3 mt-lg-0">
                                <a href="{{route('lk.products.upload')}}" class="btn btn-danger waves-effect waves-light"><i class="mdi mdi-plus-circle mr-1"></i> Загрузить из файла</a>
                            </div>
                        </div><!-- end col-->
                    </div> <!-- end row -->
                </div> <!-- end card-box -->
            </div> <!-- end col-->
        </div>
        <!-- end row-->

        <form action="{{route('lk.products.store')}}" method="post" enctype="multipart/form-data" class="image_upload">
            @csrf

        <div class="row">
            <div class="col-lg-6">
                <div class="card-box">
                    <h5 class="text-uppercase bg-light p-2 mt-0 mb-3">General</h5>

                    <div class="form-group mb-3">
                        <label for="product-name">Наименование товара <span class="text-danger">*</span></label>
                        <input type="text" id="product-name" name="product-name" class="form-control" placeholder="e.g : Apple iMac">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-name">Баркод <span class="text-danger">*</span></label>
                        <input type="text" id="product-barcode" name="product-barcode" class="form-control" placeholder="e.g : Apple iMac">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-name">Артикул (sku) <span class="text-danger">*</span></label>
                        <input type="text" id="product-sku" name="product-sku" class="form-control" placeholder="e.g : Apple iMac">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-reference">Модель <span class="text-danger">*</span></label>
                        <input type="text" id="product-model" name="product-model" class="form-control" placeholder="e.g : Apple iMac">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-category">Страна производства <span class="text-danger">*</span></label>
                        <select class="form-control select2" id="product-region" name="product-region">
                            @foreach($regions as $region)
                                <option value="{{$region->id}}">{{$region->name}}</option>
                            @endforeach
                        </select>
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-description">Product Description <span class="text-danger">*</span></label>
                        <textarea class="form-control" id="product-description" name="product-description" rows="5" placeholder="Please enter description"></textarea>
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-summary">Product Summary</label>
                        <textarea class="form-control" id="product-summary" name="product-summary" rows="3" placeholder="Please enter summary"></textarea>
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-category">Базовая категория <span class="text-danger">*</span>({{count($categories)}})</label>
                        <select class="form-control select2" id="product-base_category" name="product-base_category">
                            @foreach($categories as $category)
                                <option value="{{$category->id}}">{{$category->name}}</option>
                            @endforeach
                        </select>
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-category">Категория <span class="text-danger">*</span></label>
                        <select class="form-control select2" id="product-category" name="product-category">
                            @foreach($categories as $category)
                                <option value="{{$category->id}}">{{$category->name}}</option>
                            @endforeach
                        </select>
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-category">Сегмент <span class="text-danger">*</span>({{count($categories)}})</label>
                        <select class="form-control select2" id="product-segment" name="product-segment">
                            <option value="low-priced">Эконом</option>
                            <option value="middle-priced">Средний</option>
                            <option value="high-priced">Высокий</option>
                            <option value="luxury">Премиум</option>
                        </select>
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-base_price">Базовая оптовая цена <span class="text-danger">*</span></label>
                        <input type="text" class="form-control" id="product-base_price" name="product-base_price" placeholder="Enter amount">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-drop_price">Оптовая цена по дропшиппингу</label>
                        <input type="text" class="form-control" id="product-drop_price" name="product-drop_price" placeholder="Enter amount">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-discount">Скидка</label>
                        <input type="text" class="form-control" id="product-discount" name="product-discount" placeholder="5% или 500">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-price">РРЦ<span class="text-danger">*</span></label>
                        <input type="text" class="form-control" id="product-price" name="product-price" placeholder="Enter amount">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-min_order">Минимальный заказ (шт) </label>
                        <input type="text" class="form-control" id="product-min_order" name="product-min_order" placeholder="Enter amount">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-category">Цвет <span class="text-danger">*</span></label>
                        <select class="form-control select2" id="product-color" name="product-color">
                            @foreach($colors as $color)
                                <option value="{{$color->id}}">{{$color->title}}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="form-group mb-3">
                        <label for="product-sizes">Размеры <span class="text-danger">*</span></label>
                        @foreach($sizes as $size)
                            <div class="form-group row mb-3">
                                <label class="col-form-label">{{$size->title}}</label>
                                <div class="col-sm-2">
                                    <input type="text" name="product-sizes[{{$size->id}}]" class="form-control" placeholder="1">
                                </div>
                                <label class="col-form-label">шт.</label>
                            </div>
                        @endforeach
                    </div>

                    <div class="form-group mb-3">
                        <label class="mb-2">Модификация товара (Выберите товар) <span class="text-danger">*</span></label>
                        <select class="form-control select2" id="product-modification" name="product-modification">
                                <option value="0">Выберите базовый товар</option>
                            @foreach($products as $product)
                                <option value="{{$product->product_id}}">{{$product->name}}</option>
                            @endforeach
                        </select>
                    </div>

                    <div class="form-group mb-3">
                        <label class="mb-2">Статус <span class="text-danger">*</span></label>
                        <select class="form-control select2" id="product-status" name="product-status">
                            @foreach($statuses as $value=>$title)
                                <option value="{{$value}}">{{$title}}</option>
                            @endforeach
                        </select>
                    </div>

                    <div class="form-group mb-0">
                        <label>Comment</label>
                        <textarea class="form-control" rows="3" placeholder="Please enter comment"></textarea>
                    </div>
                </div> <!-- end card-box -->
            </div> <!-- end col -->

            <div class="col-lg-6">

                <div class="card-box">
                    <h5 class="text-uppercase mt-0 mb-3 bg-light p-2">Product Images</h5>

                    <input name="images[]" type="file" multiple />

                </div> <!-- end col-->

                <div class="card-box">
                    <h5 class="text-uppercase mt-0 mb-3 bg-light p-2">Meta Data</h5>

                    <div class="form-group mb-3">
                        <label for="product-meta-title">Meta title</label>
                        <input type="text" class="form-control" id="product-meta-title" placeholder="Enter title">
                    </div>

                    <div class="form-group mb-3">
                        <label for="product-meta-keywords">Meta Keywords</label>
                        <input type="text" class="form-control" id="product-meta-keywords" placeholder="Enter keywords">
                    </div>

                    <div class="form-group mb-0">
                        <label for="product-meta-description">Meta Description </label>
                        <textarea class="form-control" rows="5" id="product-meta-description" placeholder="Please enter description"></textarea>
                    </div>
                </div> <!-- end card-box -->

            </div> <!-- end col-->
        </div>
        <!-- end row -->

        <div class="row">
            <div class="col-12">
                <div class="text-center mb-3">
                    <button type="button" class="btn w-sm btn-light waves-effect">Cancel</button>
                    <button type="submit" class="btn w-sm btn-success waves-effect waves-light">Save</button>
                </div>
            </div> <!-- end col -->
        </div>
        <!-- end row -->

        </form>

        <!-- file preview template -->
        <div class="d-none" id="uploadPreviewTemplate">
            <div class="card mt-1 mb-0 shadow-none border">
                <div class="p-2">
                    <div class="row align-items-center">
                        <div class="col-auto">
                            <img data-dz-thumbnail src="#" class="avatar-sm rounded bg-light" alt="">
                        </div>
                        <div class="col pl-0">
                            <a href="javascript:void(0);" class="text-muted font-weight-bold" data-dz-name></a>
                            <p class="mb-0" data-dz-size></p>
                        </div>
                        <div class="col-auto">
                            <!-- Button -->
                            <a href="" class="btn btn-link btn-lg text-muted" data-dz-remove>
                                <i class="dripicons-cross"></i>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>


    </div> <!-- container -->
@endsection

@section('script')
    <!-- Plugins js-->
    <script src="{{asset('assets/libs/select2/select2.min.js')}}"></script>
    <script src="{{asset('assets/libs/summernote/summernote.min.js')}}"></script>
    <script src="{{asset('assets/libs/dropzone/dropzone.min.js')}}"></script>

    <!-- Page js-->
    <script src="{{asset('assets/js/pages/form-fileuploads.init.js')}}"></script>
    <script src="{{asset('assets/js/pages/add-product.init.js')}}"></script>
@endsection